=== debian/changelog ===
pd-pure (0.24-1) xenial; urgency=medium

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Mon, 20 Feb 2017 05:15:13 +0100

pd-pure (0.23-1) xenial; urgency=medium

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Tue, 10 Jan 2017 15:45:55 +0100

pd-pure (0.22-1) xenial; urgency=medium

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Sat, 07 Jan 2017 09:32:48 +0100

pd-pure (0.21-1) xenial; urgency=medium

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Sat, 25 Jun 2016 20:53:39 +0200

pd-pure (0.20-3) xenial; urgency=medium

  * Latest upstream fixes

 -- Albert Graef <aggraef@gmail.com>  Mon, 20 Jun 2016 08:21:38 +0200

pd-pure (0.20-2) xenial; urgency=medium

  * Latest upstream fixes

 -- Albert Graef <aggraef@gmail.com>  Mon, 20 Jun 2016 06:53:21 +0200

pd-pure (0.20-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Tue, 23 Sep 2014 07:11:57 +0200

pd-pure (0.18-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Sat, 13 Sep 2014 22:53:31 +0200

pd-pure (0.16-1) natty; urgency=low

  * Initial release

 -- Albert Graef <Dr.Graef@t-online.de>  Thu, 24 May 2012 23:21:11 +0200
