=== debian/control ===
Source: pd-pure
Section: devel
Priority: extra
Maintainer: Albert Graef <aggraef@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), pure-dev, puredata
Standards-Version: 3.9.5
Homepage: http://purelang.bitbucket.org

Package: pd-pure
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Pd loader plugin for the Pure programming language
 Pure is a modern-style functional programming language based on term
 rewriting. This package provides a Pd loader plugin which lets you write
 external Pd objects in Pure.
 .
 Note: After installing this package, you still have to tell Pd to load the
 Pure external at startup, by specifying 'pure' in the File/Startup options
 (Media/Preferences/Startup in Pd 0.43 and later). This setting can be saved
 so that the Pure loader is always available when you run Pd. Once the Pure
 loader has been enabled, you should see a message in the Pd main window
 indicating that the external has been loaded.
